﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Drawing;

namespace Comparer
{
	public class SettingsClass
	{
		public List<Plug> plugins;
		public List<WLXPlug> wlxplugins;
		public List<Comparer> comparers;
		public Int32 sizeX = 600;
		public Int32 sizeY = 350;			
		public IniFile inifile;
		private Boolean firstrun = true;
		public Boolean resetsize = false;
		public Boolean closecmp = true;
		public Boolean alwaystop = true;
		
		public Boolean showempty = false;
		public Boolean showdifferent = false;
		public Boolean remembersize = false;
		public Int32 size_label = 150;
		public Int32 size_scol = 150;
		public Int32 size_dcol1 = 90;
		public Int32 size_dcol2 = 90;
		public Boolean showthumbs = false;
		public Boolean showicons = false;
		public Int32 thumbsheight = 134;
		public Boolean isenabled = true;
		public String plugsdir = "";
		public Boolean stickmode = false;
		public Boolean wordwrap = false;
		public Int32 fieldsW = 90;
		public Int32 fieldsH = 90;
		public String outsname = "";
		public String outdname = "";

		public String sepchar = "";
		public Boolean surquotes = true;

		//image header
		public Boolean imgshowhead = false;
		public Int32 imgheadheight = 200;
		public Int32 imgheadwidth = 400;
		public String imgfontname = "Microsoft Sans Serif";
		public Int32 imgfontsize = 8;
		public String imgfontstyle = "Regular";
		public String imgshead = "";
		public String imgdhead = "";
		public Color imgcolour = Color.Black;

		public String langfile= "";
		private LangEngine _lang;		
		//run output file in associated application
		public Boolean runassapp = false;

		//last ini file (for configs combo)
		public String ininame = "";
		public Boolean rememberlastini = false;
		public String lastinifile = "$";


		public SettingsClass(String filename)
		{
			if (File.Exists( filename ))
			{
				firstrun = false;
			}
			
			//MessageBox.Show( filename );
			inifile = new IniFile( filename );
			plugins = new List<Plug>();
			wlxplugins = new List<WLXPlug>();
			comparers = new List<Comparer>();
			this._lang = new LangEngine();			
		}

		public void ReadGeneral()
		{		
			if (!firstrun)
			{
				//MessageBox.Show( this.inifile.Path.ToString() );
				//General Settings
				remembersize = Int32ToBoolean( inifile.GetInt32( "General", "RememberSize", 0 ) );
				if (remembersize)
				{
					sizeX = inifile.GetInt32( "General", "SizeX", 600 );
					sizeY = inifile.GetInt32( "General", "SizeY", 400 );
					size_label = inifile.GetInt32( "General", "SizeLabel", 150 );
					size_scol = inifile.GetInt32( "General", "SizeSingleColumn", 150 );
					size_dcol1 = inifile.GetInt32( "General", "SizeDoubleColumn1", 90 );
					size_dcol2 = inifile.GetInt32( "General", "SizeDoubleColumn2", 90 );					
					fieldsW = inifile.GetInt32( "General", "FieldsFormWidth", 300 );
					fieldsH = inifile.GetInt32( "General", "FieldsFormHeight", 300 );
				}
				else
				{
					sizeX = 600;
					sizeY = 400;

					size_label = 150;
					size_scol = 150;
					size_dcol1 = 90;
					size_dcol2 = 90;

					fieldsW = 300;
					fieldsH = 300;
				}
				closecmp = Int32ToBoolean( inifile.GetInt32( "General", "ComparerClose", 1 ) );
				alwaystop = Int32ToBoolean( inifile.GetInt32( "General", "AlwaysOnTop", 1 ) );				
				showempty = Int32ToBoolean( inifile.GetInt32( "General", "ShowEmpty", 0 ) );
				showdifferent = Int32ToBoolean( inifile.GetInt32( "General", "ShowDifferent", 0 ) );
				showthumbs = Int32ToBoolean( inifile.GetInt32( "General", "ShowThumbs", 0 ) );
				showicons = Int32ToBoolean( inifile.GetInt32( "General", "ShowIcons", 0 ) );
				thumbsheight = inifile.GetInt32( "General", "ThumbsHeight", 134 );
				stickmode = Int32ToBoolean( inifile.GetInt32( "General", "StickMode", 0 ) );
				wordwrap = Int32ToBoolean( inifile.GetInt32( "General", "WordWrap", 0 ) );

				langfile = inifile.GetString( "General", "LangFile", "$" );
				String tmplfile = "%APP_PATH%\\langs\\" + langfile;
				tmplfile = AppPathToExe( tmplfile );
				this._lang.LoadLanguage( tmplfile );


				String tmp2 = inifile.GetString( "General", "PlugsDir", "" );

				if (tmp2.Equals( "" ))
				{
					String tmpapp = Application.ExecutablePath;
					tmpapp = tmpapp.Remove( tmpapp.LastIndexOf( "\\" ) + 1 );

					plugsdir = tmpapp + "plugins\\";
				}
				else
				{
					plugsdir = PlugPathToPlugins( tmp2 );
					plugsdir = AppPathToExe(tmp2);
				}

				outsname = inifile.GetString( "Export", "SingleOutName", "output" );
				outdname = inifile.GetString( "Export", "DoubleOutName", "output" );

				surquotes = Int32ToBoolean( inifile.GetInt32( "Export", "SurQuotes", 1 ) );
				sepchar = inifile.GetString( "Export", "Separator", ";" );

				//image header
				imgshowhead = Int32ToBoolean( inifile.GetInt32( "Export", "ImgHeadShow", 0 ) );
				imgheadheight = inifile.GetInt32( "Export", "ImgHeadHeight",200 );
				imgheadwidth = inifile.GetInt32( "Export", "ImgHeadWidth", 400 );
				imgfontname = inifile.GetString( "Export", "ImgHeadFontName", "Microsoft Sans Serif" );
				imgfontsize = inifile.GetInt32( "Export", "ImgHeadFontSize", 8 );
				imgfontstyle = inifile.GetString( "Export", "ImgHeadFontStyle", "Regular" );
				imgshead = inifile.GetString( "Export", "ImgHeadSingle", "%fs" );
				imgdhead = inifile.GetString( "Export", "ImgHeadDouble", "%f1s_%f2s" );

				String tmp = inifile.GetString( "Export", "ImgHeadColour", "0,0,0" );
				String[] tmpcols = tmp.Split( ',' );
				
				if (tmpcols.Length == 3)
				{
					imgcolour = Color.FromArgb( Int32.Parse( tmpcols[0] ), Int32.Parse( tmpcols[1] ), Int32.Parse( tmpcols[2] ) );
				}
				else
				{
					imgcolour = Color.Black;
				}

				runassapp = Int32ToBoolean( inifile.GetInt32( "Export", "RunAssocApp", 0 ) );

				//last INI
				//ininame = inifile.GetString( "General", "IniName", "default" );
				ininame = inifile.GetString( "General", "IniName", GetLangText( "DefaultName" ) );
				rememberlastini = Int32ToBoolean( inifile.GetInt32( "General", "RememberLastIni", 0 ) );
				lastinifile = inifile.GetString( "General", "LastIniFile", "$" );

			}
			else
			{
				String tmpapp = Application.ExecutablePath;
				tmpapp = tmpapp.Remove( tmpapp.LastIndexOf( "\\" ) + 1 );

				plugsdir = tmpapp + "plugins\\";

				remembersize = false;
				sizeX = 600;
				sizeY = 400;

				size_label = 150;
				size_scol = 150;
				size_dcol1 = 90;
				size_dcol2 = 90;

				fieldsW = 300;
				fieldsH = 300;

				closecmp = true;
				alwaystop = true;
				showempty = false;
				showdifferent = Int32ToBoolean( inifile.GetInt32( "General", "ShowDifferent", 0 ) );
				showthumbs = Int32ToBoolean( inifile.GetInt32( "General", "ShowThumbs", 0 ) );
				showicons = Int32ToBoolean( inifile.GetInt32( "General", "ShowIcons", 0 ) );
				thumbsheight = inifile.GetInt32( "General", "ThumbsHeight", 134 );
				stickmode = Int32ToBoolean( inifile.GetInt32( "General", "StickMode", 0 ) );
				wordwrap = Int32ToBoolean( inifile.GetInt32( "General", "WordWrap", 0 ) );

				langfile = inifile.GetString( "General", "LangFile", "$" );
				String tmplfile = "%APP_PATH%\\langs\\" + langfile;
				tmplfile = AppPathToExe( tmplfile );
				this._lang.LoadLanguage( tmplfile );

				outsname = "output";
				outdname = "output";

				surquotes = true;
				sepchar = ";";

				//image header
				imgshowhead = false; ;
				imgheadheight = 200;
				imgheadwidth = 400;
				imgfontname = "Microsoft Sans Serif";
				imgfontsize = 8;
				imgfontstyle = "Regular";
				imgshead = "%fs";
				imgdhead = "%f1s_%f2s";

				imgcolour = Color.Black;


				runassapp = false; ;

				//last INI
				ininame = GetLangText( "DefaultName" );
				rememberlastini = false; ;
				lastinifile = "$";


			}
			
			//MessageBox.Show( plugsdir );
		}

		private Boolean Int32ToBoolean(Int32 value)
		{
			if (value >= 1)
			{
				return true;
			}

			return false;
		}

		private Int32 BooleanToInt32(Boolean value)
		{
			if (value)
			{
				return 1;
			}

			return 0;
		}
		
		public void ReadAllPlugins( )
		{
			this.plugins = new List<Plug>();
			
			Int32 plugcount = inifile.GetInt32( "Plugins", "PluginsCount", 0 );

			plugins = new List<Plug>();
			
			if (plugcount > 0)
			{
				
				for (int i = 0; i < plugcount; i++)
				{
					String path = inifile.GetString( "Plugins", "Path" + i.ToString(), "" );
					if (!path.Equals( "" ))
					{
						path = PlugPathToPlugins( path );
						path = AppPathToExe( path );

						String exts = inifile.GetString( "Plugins", "Extensions" + i.ToString(), "" );

						String flds = inifile.GetString( "Plugins", "Fields" + i.ToString(), "*" );

						plugins.Add( new Plug( path, exts, flds ) );
					}
				}
				
			}
		}

		public void ReadAllWLXPlugins()
		{			
			wlxplugins = new List<WLXPlug>();			

			Int32 plugcount = inifile.GetInt32( "WLXPlugins", "PluginsCount", 0 );

			wlxplugins = new List<WLXPlug>();

			if ((inifile.GetKeyNames( "WLXPlugins" ).Length == (plugcount * 2 + 1)) && (plugcount > 0))
			{

				for (int i = 0; i < plugcount; i++)
				{
					String path = inifile.GetString( "WLXPlugins", "Path" + i.ToString(), "" );

					if (!path.Equals( "" ))
					{
						path = PlugPathToPlugins( path );
						path = AppPathToExe( path );

						String exts = inifile.GetString( "WLXPlugins", "Extensions" + i.ToString(), "" );	

						wlxplugins.Add( new WLXPlug( path, exts ) );
					}
				}

			}
		}

		public void ReadAllComparers()
		{			
			comparers = new List<Comparer>();

			Int32 compcount = inifile.GetInt32( "Comparers", "CompCount", 0 );

			comparers = new List<Comparer>();

			if ((inifile.GetKeyNames( "Comparers" ).Length == (compcount * 3 + 1)) && (compcount > 0))
			{

				for (int i = 0; i < compcount; i++)
				{
					String path = inifile.GetString( "Comparers", "Path" + i.ToString(), "" );

					if (!path.Equals( "" ))
					{
						path = PlugPathToPlugins( path );
						path = AppPathToExe( path );

						String exts = inifile.GetString( "Comparers", "Extensions" + i.ToString(), "" );
						String pars = inifile.GetString( "Comparers", "Params" + i.ToString(), "" );
						

						comparers.Add( new Comparer( path, exts, pars ) );
					}
				}

			}
		}

		public void ReadPlugins(String extension)
		{
			if (!firstrun)
			{
				Int32 plugcount = inifile.GetInt32( "Plugins", "PluginsCount", 0 );				

				plugins = new List<Plug>();

				//if ((inifile.GetKeyNames( "Plugins" ).Length == (plugcount * 2 + 1)) && (plugcount > 0))
				if (plugcount > 0)
				{

					for (int i = 0; i < plugcount; i++)
					{
						String path = inifile.GetString( "Plugins", "Path" + i.ToString(), "" );

						if (!path.Equals( "" ))
						{
							String exts = inifile.GetString( "Plugins", "Extensions" + i.ToString(), "" );

							if (exts.ToUpper().Contains( "*" + extension.ToUpper() ) || exts.ToUpper().Contains( "*.*" ))
							{
								path = PlugPathToPlugins( path );
								path = AppPathToExe( path );

								String flds = inifile.GetString( "Plugins", "Fields" + i.ToString(), "*" );

								plugins.Add( new Plug( path, exts, flds ) );								
							}
						}
					}
				}
				else
				{
					//MessageBox.Show( "Invalid number of keys for PluginsCount="+ plugcount.ToString() +" !" );
				}
			}
		}

		public void ReadWLXPlugins( String extension )
		{
			if (!firstrun)
			{
				Int32 plugcount = inifile.GetInt32( "WLXPlugins", "PluginsCount", 0 );

				wlxplugins = new List<WLXPlug>();

				if ((inifile.GetKeyNames( "WLXPlugins" ).Length == (plugcount * 2 + 1)) && (plugcount > 0))
				{
					for (int i = 0; i < plugcount; i++)
					{
						String path = inifile.GetString( "WLXPlugins", "Path" + i.ToString(), "" );

						if (!path.Equals( "" ))
						{
							String exts = inifile.GetString( "WLXPlugins", "Extensions" + i.ToString(), "" );

							if (exts.ToUpper().Contains( "*" + extension.ToUpper() ) || exts.ToUpper().Contains( "*.*" ))
							{
								path = PlugPathToPlugins( path );
								path = AppPathToExe( path );

								wlxplugins.Add( new WLXPlug( path, exts ) );
							}
						}
					}
				}
				else
				{
					//MessageBox.Show( "Invalid number of keys for PluginsCount=" + plugcount.ToString() + " !" );
				}
			}
		}
						
		public void ReadPlugins( String extension, String extension2 )
		{
			if (!firstrun)
			{
				Int32 plugcount = inifile.GetInt32( "Plugins", "PluginsCount", 0 );
				plugins = new List<Plug>();

				//if ((inifile.GetKeyNames( "Plugins" ).Length == (plugcount * 2 + 1)) && (plugcount > 0))
				if (plugcount > 0)
				{
					List<Plug> ext1plugins = new List<Plug>();
					List<Plug> ext2plugins = new List<Plug>();

					for (int i = 0; i < plugcount; i++)
					{
						String path = inifile.GetString( "Plugins", "Path" + i.ToString(), "" );

						if (!path.Equals( "" ))
						{
							path = PlugPathToPlugins( path );
							path = AppPathToExe( path );

							String flds = inifile.GetString( "Plugins", "Fields" + i.ToString(), "*" );

							String exts = inifile.GetString( "Plugins", "Extensions" + i.ToString(), "" );

							if (exts.ToUpper().Contains( "*" + extension.ToUpper() ) || exts.ToUpper().Contains( "*.*" ))
							{
								ext1plugins.Add( new Plug( path, exts, flds ) );
							}

							if (exts.ToUpper().Contains( "*" + extension2.ToUpper() ) || exts.ToUpper().Contains( "*.*" ))
							{
								ext2plugins.Add( new Plug( path, exts, flds ) );
							}
						}
					}

					for (int i = 0; i < ext1plugins.Count; i++)
					{
						for (int j = 0; j < ext2plugins.Count; j++)
						{
							if (ext1plugins[i]._path.ToString().Equals( ext2plugins[j]._path.ToString() ))
							{
								plugins.Add( new Plug( ext1plugins[i]._path, ext1plugins[i]._exts, ext1plugins[i]._fields ) );
								break;
							}
						}
					}
				}

			}							
		}

		public void ReadWLXPlugins( String extension, String extension2 )
		{
			if (!firstrun)
			{
				Int32 plugcount = inifile.GetInt32( "WLXPlugins", "PluginsCount", 0 );
				wlxplugins = new List<WLXPlug>();

				if ((inifile.GetKeyNames( "WLXPlugins" ).Length == (plugcount * 2 + 1)) && (plugcount > 0))
				{
					List<WLXPlug> ext1plugins = new List<WLXPlug>();
					List<WLXPlug> ext2plugins = new List<WLXPlug>();

					for (int i = 0; i < plugcount; i++)
					{
						String path = inifile.GetString( "WLXPlugins", "Path" + i.ToString(), "" );

						if (!path.Equals( "" ))
						{
							path = PlugPathToPlugins( path );
							path = AppPathToExe( path );

							String exts = inifile.GetString( "WLXPlugins", "Extensions" + i.ToString(), "" );
							
							if (exts.ToUpper().Contains( "*" + extension.ToUpper() ) || exts.ToUpper().Contains( "*.*" ))
							{
								ext1plugins.Add( new WLXPlug( path, exts ) );
							}

							if (exts.ToUpper().Contains( "*" + extension2.ToUpper() ) || exts.ToUpper().Contains( "*.*" ))
							{
								ext2plugins.Add( new WLXPlug( path, exts ) );
							}
						}
					}

					for (int i = 0; i < ext1plugins.Count; i++)
					{
						for (int j = 0; j < ext2plugins.Count; j++)
						{
							if (ext1plugins[i]._path.ToString().Equals( ext2plugins[j]._path.ToString() ))
							{
								wlxplugins.Add( new WLXPlug( ext1plugins[i]._path, ext1plugins[i]._exts ) );
								break;
							}
						}
					}
				}

			}

			//for (int i = 0; i < ext1plugins.Count; i++)


		}

		public void ReadComparers( String extension, String extension2 )
		{
			if (!firstrun)
			{
				Int32 comcount = inifile.GetInt32( "Comparers", "CompCount", 0 );
				comparers = new List<Comparer>();

				if ((inifile.GetKeyNames( "Comparers" ).Length == (comcount * 3 + 1)) && (comcount > 0))
				{
					List<Comparer> ext1comps = new List<Comparer>();
					List<Comparer> ext2comps = new List<Comparer>();

					for (int i = 0; i < comcount; i++)
					{						
						String path = inifile.GetString( "Comparers", "Path" + i.ToString(), "" );

						if (!path.Equals( "" ))
						{
							path = PlugPathToPlugins( path );
							path = AppPathToExe( path );

							String exts = inifile.GetString( "Comparers", "Extensions" + i.ToString(), "" );

							String compparam = inifile.GetString( "Comparers", "Params" + i.ToString(), "" );

							if (exts.ToUpper().Contains( "*" + extension.ToUpper() ) || exts.ToUpper().Contains( "*.*" ))
							{
								ext1comps.Add( new Comparer( path, exts, compparam ) );
							}

							if (exts.ToUpper().Contains( "*" + extension2.ToUpper() ) || exts.ToUpper().Contains( "*.*" ))
							{
								ext2comps.Add( new Comparer( path, exts, compparam ) );
							}
						}
					}

					for (int i = 0; i < ext1comps.Count; i++)
					{
						for (int j = 0; j < ext2comps.Count; j++)
						{
							if (ext1comps[i]._path.ToString().Equals( ext2comps[j]._path.ToString() ))
							{
								comparers.Add( new Comparer( ext1comps[i]._path, ext1comps[i]._exts, ext1comps[i]._param ) );
								break;
							}
						}
					}
				}

			}
		}
		
		public void SetSize(Int32 wid, Int32 hei)
		{			
			//General Settings

			if (this.resetsize)
			{
				inifile.WriteValue( "General", "SizeX", 600 );
				inifile.WriteValue( "General", "SizeY", 400 );
			}
			else
			{
				inifile.WriteValue( "General", "SizeX", wid );
				inifile.WriteValue( "General", "SizeY", hei );
			}
		}

		public void SetColumns(Int32 lab, Int32 scol, Int32 dcol1, Int32 dcol2)
		{
			if (this.resetsize)
			{
				inifile.WriteValue( "General", "SizeLabel", 150 );
				inifile.WriteValue( "General", "SizeSingleColumn", 150 );
				inifile.WriteValue( "General", "SizeDoubleColumn1", 90 );
				inifile.WriteValue( "General", "SizeDoubleColumn2", 90 );
			}
			else
			{
				inifile.WriteValue( "General", "SizeLabel", lab );
				inifile.WriteValue( "General", "SizeSingleColumn", scol );
				inifile.WriteValue( "General", "SizeDoubleColumn1", dcol1 );
				inifile.WriteValue( "General", "SizeDoubleColumn2", dcol2 );
			}
		}		

		public void SaveGeneral()
		{
			if (this.remembersize)
			{
				inifile.WriteValue( "General", "SizeX", this.sizeX );
				inifile.WriteValue( "General", "SizeY", this.sizeY );

				inifile.WriteValue( "General", "SizeLabel", this.size_label );
				inifile.WriteValue( "General", "SizeSingleColumn", this.size_scol );
				inifile.WriteValue( "General", "SizeDoubleColumn1", this.size_dcol1 );
				inifile.WriteValue( "General", "SizeDoubleColumn2", this.size_dcol2 );
				inifile.WriteValue( "General", "FieldsFormWidth", this.fieldsW );
				inifile.WriteValue( "General", "FieldsFormHeight", this.fieldsH );
			}
			
			inifile.WriteValue( "General", "ComparerClose", BooleanToInt32( this.closecmp) );
			inifile.WriteValue( "General", "AlwaysOnTop", BooleanToInt32( this.alwaystop ) );
			inifile.WriteValue( "General", "ShowEmpty", BooleanToInt32( this.showempty ) );
			inifile.WriteValue( "General", "ShowDifferent", BooleanToInt32( this.showdifferent ) );
			inifile.WriteValue( "General", "RememberSize", BooleanToInt32( this.remembersize ) );
			inifile.WriteValue( "General", "ShowThumbs", BooleanToInt32( this.showthumbs ) );
			inifile.WriteValue( "General", "ThumbsHeight", this.thumbsheight );
			inifile.WriteValue( "General", "ShowIcons", BooleanToInt32( this.showicons ) );
			inifile.WriteValue( "General", "StickMode", BooleanToInt32( this.stickmode ) );
			inifile.WriteValue( "General", "WordWrap", BooleanToInt32( this.wordwrap ) );

			String tmp = this.plugsdir;
			tmp = PlugPathToPlugins( tmp );
			tmp = ExePathToAppPath( tmp );

			inifile.WriteValue( "General", "PlugsDir", tmp );
			
			inifile.WriteValue( "General", "LangFile", langfile );

			inifile.WriteValue( "Export", "SingleOutName", this.outsname );
			inifile.WriteValue( "Export", "DoubleOutName", this.outdname );

			inifile.WriteValue( "Export", "SurQuotes", BooleanToInt32( this.surquotes ) );
			inifile.WriteValue( "Export", "Separator", this.sepchar );

			//image header
					
			inifile.WriteValue( "Export", "ImgHeadShow", BooleanToInt32( this.imgshowhead ) );
			inifile.WriteValue( "Export", "ImgHeadHeight", this.imgheadheight );
			inifile.WriteValue( "Export", "ImgHeadWidth", this.imgheadwidth );
			inifile.WriteValue( "Export", "ImgHeadFontName", this.imgfontname );			
			inifile.WriteValue( "Export", "ImgHeadFontSize", this.imgfontsize );
			inifile.WriteValue( "Export", "ImgHeadFontStyle", this.imgfontstyle );
			inifile.WriteValue( "Export", "ImgHeadSingle", this.imgshead );
			inifile.WriteValue( "Export", "ImgHeadDouble", this.imgdhead );

			String tmpcol = this.imgcolour.R.ToString() + "," + this.imgcolour.G.ToString() + "," + this.imgcolour.B.ToString();

			inifile.WriteValue( "Export", "ImgHeadColour", tmpcol );

			inifile.WriteValue( "Export", "RunAssocApp", BooleanToInt32( this.runassapp ) );


			//ccurrent INI
			//get name from changed language (completely new INI)

			if (this.ininame.Equals( "default" ))
			{
				String tmplangini = Application.ExecutablePath;
				tmplangini = tmplangini.Substring(0, tmplangini.LastIndexOf( '\\' ) + 1 );
				tmplangini = tmplangini + "langs\\" + this.langfile;

				LangEngine le = new LangEngine();
				le.LoadLanguage(tmplangini);

				this.ininame = le.GetLangString( "DefaultName" );
				
			}

			inifile.WriteValue( "General", "IniName", this.ininame );


			//custom INIs
			if (this.rememberlastini)
			{
				inifile.WriteValue( "General", "RememberLastIni", BooleanToInt32( this.rememberlastini ) );

				String tmpini = this.lastinifile;
				tmpini = tmpini.Substring(tmpini.LastIndexOf('\\') +1);
				
				inifile.WriteValue( "General", "LastIniFile", tmpini );				
			}
			else
			{
				inifile.DeleteKey("General", "RememberLastIni");
				inifile.DeleteKey( "General", "LastIniFile" );				
			}
		}

		public void SavePlugins()
		{
			//TODO: body
			inifile.DeleteSection( "Plugins" );
			inifile.WriteValue( "Plugins", "PluginsCount", this.plugins.Count );

			for (int i = 0; i < this.plugins.Count; i++)
			{				
				String tmppath = this.plugins[i]._path;

				tmppath = PluginsToPlugPath( tmppath );
				tmppath = ExePathToAppPath( tmppath );

				inifile.WriteValue( "Plugins", "Path" + i.ToString(), tmppath  );
				
				inifile.WriteValue( "Plugins", "Extensions" + i.ToString(), this.plugins[i]._exts );
				inifile.WriteValue( "Plugins", "Fields" + i.ToString(), this.plugins[i]._fields );
			}
		}

		public void SaveWLXPlugins()
		{
			//TODO: body
			inifile.DeleteSection( "WLXPlugins" );
			inifile.WriteValue( "WLXPlugins", "PluginsCount", this.wlxplugins.Count );

			for (int i = 0; i < this.wlxplugins.Count; i++)				
			{
				String tmppath = this.wlxplugins[i]._path;
				tmppath = PluginsToPlugPath( tmppath );
				tmppath = ExePathToAppPath( tmppath );
	
				inifile.WriteValue( "WLXPlugins", "Path" + i.ToString(), tmppath );
				inifile.WriteValue( "WLXPlugins", "Extensions" + i.ToString(), this.wlxplugins[i]._exts );			
			}
		}

		public void SaveComparers()
		{			
			inifile.DeleteSection( "Comparers" );
			inifile.WriteValue( "Comparers", "CompCount", this.comparers.Count );

			for (int i = 0; i < this.comparers.Count; i++)
			{
				String tmppath = this.comparers[i]._path;
				tmppath = PluginsToPlugPath( tmppath );
				tmppath = ExePathToAppPath( tmppath );			
			
				inifile.WriteValue( "Comparers", "Path" + i.ToString(), tmppath );
				inifile.WriteValue( "Comparers", "Extensions" + i.ToString(), this.comparers[i]._exts );
				inifile.WriteValue( "Comparers", "Params" + i.ToString(), this.comparers[i]._param );
			}
		}

		public String ExePathToAppPath( String path )
		{
			String exepath = Application.ExecutablePath;
			if (exepath.LastIndexOf( "\\" ) >= 0)
			{
				exepath = exepath.Remove( exepath.LastIndexOf( "\\" ) );
			}
			path = path.Replace( exepath, "%APP_PATH%" );

			return path;
		}

		public String AppPathToExe( String path )
		{
			String exepath = Application.ExecutablePath;
			if (exepath.LastIndexOf( "\\" ) >= 0)
			{
				exepath = exepath.Remove( exepath.LastIndexOf( "\\" ) );
			}
			path = path.Replace( "%APP_PATH%", exepath );

			return path;
		}

		public String PluginsToPlugPath( String path )
		{
			String exepath = this.plugsdir;

			
			if (exepath.LastIndexOf( "\\" ) >= 0)
			{
				exepath = exepath.Remove( exepath.LastIndexOf( "\\" ) );
			}
			

			path = path.Replace( exepath, "%PLUG_PATH%" );

			return path;
		}

		public String PlugPathToPlugins( String path )
		{
			String exepath = this.plugsdir;
			
			
			if (exepath.LastIndexOf( "\\" ) >= 0)
			{
				exepath = exepath.Remove( exepath.LastIndexOf( "\\" ) );
			}
			
			path = path.Replace( "%PLUG_PATH%", exepath );

			return path;
		}

		public String GetLangText(String key)
		{
			return this._lang.GetLangString( key );
		}

		
	}	
}
